Dumps the internal XML tree back into a file

- « DOMDocument::replaceChildren

- DOMDocument::saveHTML »

- PHP Manual
- DOMDocument
- Dumps the internal XML tree back into a file

# DOMDocument::save

(PHP 5, PHP 7, PHP 8)

DOMDocument::save — Dumps the internal XML tree back into a file

### Description

public DOMDocument::save(string `$filename`, int `$options` = 0): int|false

Creates an XML document from the DOM representation. This function is usually called after building a new dom document from scratch as in the example below.

### Parameters

`filename`

  The path to the saved XML document.

`options`

  Additional Options. Currently only LIBXML_NOEMPTYTAG is supported.

### Return Values

Returns the number of bytes written or `false` if an error occurred.

### Examples

Example #1 Saving a DOM tree into a file

    <?php

    $doc = new DOMDocument('1.0');
    // we want a nice output
    $doc->formatOutput = true;

    $root = $doc->createElement('book');
    $root = $doc->appendChild($root);

    $title = $doc->createElement('title');
    $title = $root->appendChild($title);

    $text = $doc->createTextNode('This is the title');
    $text = $title->appendChild($text);

    echo 'Wrote: ' . $doc->save("/tmp/test.xml") . ' bytes'; // Wrote: 72 bytes

    ?>

### See Also

- DOMDocument::saveXML() - Dumps the internal XML tree back into a string
- DOMDocument::load() - Load XML from a file
- DOMDocument::loadXML() - Load XML from a string